/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/@DIRECTORY/include/@COMPONENT.h"
#include "Behavioural/include/Allocation.h"

namespace morpheo                    {
namespace behavioural {
@NAMESPACE_BEGIN

#undef  FUNCTION
#define FUNCTION "@COMPONENT::deallocation"
  void @COMPONENT::deallocation (void)
  {
    log_begin(@COMPONENT,FUNCTION);

//    if (usage_is_set(_usage,USE_SYSTEMC_INTERFACE))
      { 
        DELETE0_SIGNAL( in_CLOCK ,1);
        DELETE0_SIGNAL( in_NRESET,1);
      }
    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    

    delete _component;

#ifdef MODELSIM_COSIMULATION
    if (usage_is_set(_usage,USE_COSIMULATION))
      {
        delete _wrapper;
      }
#endif

    log_end(@COMPONENT,FUNCTION);
  };

@NAMESPACE_END
}; // end namespace behavioural
}; // end namespace morpheo              
